databaseChangeLog:
- changeSet:
    id: 1
    author: kendal.blythe@gmail.com
    changes:
    - createTable:
        tableName: player
        columns:
        - column:
            name: player_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: player_nm
            type: varchar(100)
            constraints:
              nullable: false
    - addPrimaryKey:
        constraintName: player_pk
        tableName: player
        columnNames: player_id
    - createTable:
        tableName: game
        columns:
        - column:
            name: game_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: grid_config_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: grid_size_x
            type: int
            constraints:
              nullable: false
        - column:
            name: grid_size_y
            type: int
            constraints:
              nullable: false
        - column:
            name: turn_player_num
            type: int
        - column:
            name: winning_player_num
            type: int
        - column:
            name: created_date
            type: timestamp
            constraints:
              nullable: false
        - column:
            name: last_modified_date
            type: timestamp
            constraints:
              nullable: false
    - addPrimaryKey:
        constraintName: game_pk
        tableName: game
        columnNames: game_id
    - createTable:
        tableName: game_player
        columns:
        - column:
            name: game_player_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: game_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: player_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: player_num
            type: int
            constraints:
              nullable: false
    - addPrimaryKey:
        constraintName: game_player_pk
        tableName: game_player
        columnNames: game_player_id
    - addForeignKeyConstraint:
        constraintName: game_player_fk1
        baseTableName: game_player
        baseColumnNames: game_id
        referencedTableName: game
        referencedColumnNames: game_id
        onDelete: CASCADE
    - addForeignKeyConstraint:
        constraintName: game_player_fk2
        baseTableName: game_player
        baseColumnNames: player_id
        referencedTableName: player
        referencedColumnNames: player_id
        onDelete: SET NULL
    - createTable:
        tableName: game_player_ship
        columns:
        - column:
            name: game_player_ship_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: game_player_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: ship_nm
            type: varchar(100)
            constraints:
              nullable: false
        - column:
            name: ship_len
            type: int
            constraints:
              nullable: false
        - column:
            name: start_coord_x
            type: int
            constraints:
              nullable: false
        - column:
            name: start_coord_y
            type: int
            constraints:
              nullable: false
        - column:
            name: end_coord_x
            type: int
            constraints:
              nullable: false
        - column:
            name: end_coord_y
            type: int
            constraints:
              nullable: false
    - addPrimaryKey:
        constraintName: game_player_ship_pk
        tableName: game_player_ship
        columnNames: game_player_ship_id
    - addForeignKeyConstraint:
        constraintName: game_player_ship_fk1
        baseTableName: game_player_ship
        baseColumnNames: game_player_id
        referencedTableName: game_player
        referencedColumnNames: game_player_id
        onDelete: CASCADE
    - createTable:
        tableName: game_player_bomb
        columns:
        - column:
            name: game_player_bomb_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: game_player_id
            type: varchar(36)
            constraints:
              nullable: false
        - column:
            name: coord_x
            type: int
            constraints:
              nullable: false
        - column:
            name: coord_y
            type: int
            constraints:
              nullable: false
        - column:
            name: hit_flg
            type: boolean
            constraints:
              nullable: false
        - column:
            name: sunken_game_player_ship_id
            type: varchar(36)
        - column:
            name: created_date
            type: timestamp
            constraints:
              nullable: false
    - addPrimaryKey:
        constraintName: game_player_bomb_pk
        tableName: game_player_bomb
        columnNames: game_player_bomb_id
    - addForeignKeyConstraint:
        constraintName: game_player_bomb_fk1
        baseTableName: game_player_bomb
        baseColumnNames: game_player_id
        referencedTableName: game_player
        referencedColumnNames: game_player_id
        onDelete: CASCADE
    - addForeignKeyConstraint:
        constraintName: game_player_bomb_fk2
        baseTableName: game_player_bomb
        baseColumnNames: sunken_game_player_ship_id
        referencedTableName: game_player_ship
        referencedColumnNames: game_player_ship_id
        onDelete: SET NULL
    - insert:
        tableName: player
        columns:
        - column:
            name: player_id
            value: '_SYSTEM_'
        - column:
            name: player_nm
            value: 'System'
    - insert:
        tableName: player
        columns:
        - column:
            name: player_id
            value: '_ANONYMOUS_'
        - column:
            name: player_nm
            value: 'Anonymous'
